// classes for preedit draw
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <stdlib.h>
#include "xim.h"
#include "kkconv.h"
#include "convdisp.h"
#include "xdispatch.h"
#include "gtkdispatch.h"

//
// pe_winץꥨǥåѤδܥɥ
//  pe_line_win  root window style
//  pe_ov_win  over the spot
// CandidateWin ɽѤΥɥ

//IMEϥ󥿥饯ƥ֤ǤɬפΤǡ¤XFlushȤ

static XFontSet gFontset;

void init_convdisp()
{
    char **missing, *def;
    int nr_missing;
    gFontset = 
	XCreateFontSet(gDpy,
		       "-misc-fixed-medium-r-normal--14-110-100-100-c-70-iso8859-1,"
		       "-misc-fixed-medium-r-normal--14-130-75-75-c-140-jisx0208.1983-0,"
		       "-misc-fixed-medium-r-normal--14-130-75-75-c-70-jisx0201.1976-0",
		       &missing,&nr_missing,&def);
    // ktermλȤեȥåȤäƤ

    if ( missing ){
	XFreeStringList(missing);
    }
}

struct char_ent{
    cchar c;
    int stat;
    int width;
    int height;
    int x,y;
};

// ץꥨǥåWindow
class pe_win : public WindowIf{
public:
    pe_win(Window pw);
    virtual ~pe_win();

    virtual void release();
    
    virtual void destroy(Window);
    void expose(Window w);

    void draw_char(int x,int y,cchar ch,int stat);
    void set_back(unsigned long p);
    void set_fore(unsigned long p);
    void set_fontset(XFontSet f);
    
    virtual void set_size(int w,int h);
    void set_pos(int x,int y);

    void do_map();

    void clear();
    void draw();
    void unmap();
protected:
    Window mParentWin;
    Window mWin;
    Pixmap mPixmap;
    GC mGC,mClearGC;
    GC mHilitGC;
    unsigned int mFore,mBack;
    XFontSet mFontset;
    int mWidth,mHeight;
    bool mIsMapped;
};

// RootWindowStyleѤ1ԥɥ
class pe_line_win : public pe_win{
public:
    pe_line_win(Window w);
    virtual ~pe_line_win();

    void draw_pe(pe_stat *p);

    void draw_segment(pe_jstring *s);

private:
    void calc_extent(pe_stat *p);

    int m_x;
};

// over the spotѤΥɥ
class pe_ov_win : public pe_win{
public:
    pe_ov_win(Window w);
    
    void draw_ce(char_ent *ce,int len);
    virtual void set_size(int w,int h);
    virtual ~pe_ov_win();
private:
    void draw_a_ce(char_ent *ce);
    Pixmap m_mask_pix;
    GC m_mask_pix_gc;
};

//
//ɽѤΥɥ
// convdisp_ovκ˴ˤ줾˴
//
class CandidateWin : WidgetIf{
public:
    CandidateWin(Convdisp *);
    virtual ~CandidateWin();
    void update(pe_stat *);
    virtual void select_row(GtkWidget *,int,int );
    virtual void key_press(GtkWidget *w,GdkEventKey *e);

    void set_pos(int x,int y);

    void show();
    void hide();
private:
    void build_candidate_list();
    bool trim_base_row();

    GtkWidget *top_win;
    GtkWidget *clist;
    Convdisp *mConvdisp;
    pe_stat *m_pe;
    bool bInit;
    int m_select_count;
    int m_base_row;
};

class convdisp_ov : public Convdisp{
public:
    convdisp_ov(KKContext *,icxatr *);
    virtual ~convdisp_ov();
    void update_preedit();
    virtual void update_icxatr();
    virtual void set_focus();
    virtual void unset_focus();
private:
    bool check_win();
    bool check_atr();
    void calc_char_extent();
    void make_ce_array();
    void draw_preedit();
    void do_draw_preedit();
    int calc_ce_width(int b,int e);
    
    char_ent *m_ce;
    int m_ce_len;
    pe_ov_win *m_ov_win;
};

// RootWindow
class convdisp_rw : public Convdisp{
public:
    convdisp_rw(KKContext *,icxatr *);
    virtual ~convdisp_rw();

    void update_preedit();
    virtual void update_icxatr();
private:
    pe_line_win *m_pe_win;
};

class Connection;
class convdisp_os : public Convdisp{
public:
    convdisp_os(KKContext *,icxatr *,Connection *);
    virtual ~convdisp_os();
    virtual void update_preedit();
    virtual void update_icxatr();
    virtual void set_focus();
    virtual void unset_focus();

private:
    void compose_preedit_array(TxPacket *);
    void compose_feedback_array(TxPacket *);
    void update_CandidateWin();
  
    Connection *mConn;
    int mImid,mIcid;
    int mPrevLen;
};

CandidateWin *g_cur_cand_win;

Convdisp *create_convdisp(int style,KKContext *k,icxatr *a,Connection *c)
{
    switch(style){
    case IS_ROOT_WINDOW:
	return new convdisp_rw(k,a);
    case IS_OVER_THE_SPOT:
	return new convdisp_ov(k,a);
    case IS_ON_THE_SPOT:
	return new convdisp_os(k,a,c);
    default:
	break;
    }
    return 0;
}

//
// pe_win(PreeEdit Window)
//
pe_win::pe_win(Window pw)
{
    mParentWin = pw;
    int scr_num = DefaultScreen(gDpy);
    //Ŭʥ
    mWidth = 1;
    mHeight = 1;
    mWin = XCreateSimpleWindow(gDpy,mParentWin,
                                0,0,mWidth,mHeight,0,
                                BlackPixel(gDpy,scr_num),
                                WhitePixel(gDpy,scr_num));
    mPixmap = XCreatePixmap(gDpy,DefaultRootWindow(gDpy)
                             ,mWidth,mHeight,
                             DefaultDepth(gDpy,scr_num));
    
    mGC = XCreateGC(gDpy,mPixmap,0,0);
    mClearGC = XCreateGC(gDpy,mPixmap,0,0);
    mHilitGC = XCreateGC(gDpy,mPixmap,0,0);
    
    XSetBackground(gDpy,mGC,WhitePixel(gDpy,scr_num));
    XSetForeground(gDpy,mGC,BlackPixel(gDpy,scr_num));
    XSetForeground(gDpy,mClearGC,WhitePixel(gDpy,scr_num));
    XSetBackground(gDpy,mClearGC,BlackPixel(gDpy,scr_num));        
    
    add_window_watch(mWin,this,EXPOSE_MASK|STRUCTURE_NOTIFY_MASK);
    mIsMapped = false;//ޥåפƤʤ
    mFontset = gFontset;
    
    XFlush(gDpy);
}

pe_win::~pe_win()
{
    if ( mWin ){
        release();
    }

    XFreePixmap(gDpy,mPixmap);
    
    XFreeGC(gDpy,mGC);
    XFreeGC(gDpy,mClearGC);
    XFreeGC(gDpy,mHilitGC);

    XFlush(gDpy);
}

void pe_win::release()
{
    XDestroyWindow(gDpy,mWin);
    mWin = 0;
}

void pe_win::destroy(Window w)
{
    if ( mWin && mWin == w ){
        mWin = 0;
    }
}

void pe_win::expose(Window w)
{
    XCopyArea(gDpy,mPixmap,mWin,mGC,
              0,0,mWidth,mHeight,0,0);

    XFlush(gDpy);
}

void pe_win::draw_char(int x,int y,cchar ch,int stat)
{
    GC gc = mGC;
    if ( stat & PE_REVERSE ){
	gc = mClearGC;
    }
    if (stat & PE_HILIGHT ){
        //gc = mHilitGC;
    }
    
    if ( ch < 256 ){
	char c = ch;
	XmbDrawImageString(gDpy,mPixmap,mFontset,gc,x,y,&c,1);
    }else{
	unsigned char c[2];
	c[0] = ((ch >>8)&255)|0x80;
	c[1] = (ch & 255)|0x80;

	XmbDrawImageString(gDpy,mPixmap,mFontset,gc,x,y,(char *)c,2);
    }
}

void pe_win::set_back(unsigned long p)
{
    mBack = p;
    XSetBackground(gDpy,mGC,p);
    XSetForeground(gDpy,mClearGC,p);        
}

void pe_win::set_fore(unsigned long p)
{
    mFore = p;
    XSetForeground(gDpy,mGC,p);
    XSetBackground(gDpy,mClearGC,p);
}

void pe_win::set_fontset(XFontSet f)
{
    mFontset = f;
}

void pe_win::set_size(int w,int h)
{
    if ( w == mWidth && h == mHeight ){
        return ;
    }
    XResizeWindow(gDpy,mWin,w,h);
    XFreePixmap(gDpy,mPixmap);
    mPixmap =XCreatePixmap(gDpy,DefaultRootWindow(gDpy),w,h,
                            DefaultDepth(gDpy,DefaultScreen(gDpy)));
    mWidth = w;
    mHeight = h;
    clear();
}

void pe_win::set_pos(int x,int y)
{
    XWindowChanges ch;
    ch.x = x;
    ch.y = y;
    XConfigureWindow(gDpy,mWin,CWX|CWY,&ch);
}

void pe_win::do_map()
{
    if ( !mIsMapped ){
        XMapRaised(gDpy,mWin);
        XFlush(gDpy);
        mIsMapped = true;
    }
}

void pe_win::clear()
{
    XFillRectangle(gDpy,mPixmap,mClearGC,0,0,mWidth,mHeight);
}

void pe_win::draw()
{
    if ( !mIsMapped ){
        do_map();
    }else{
        expose(mWin);
    }
}

void pe_win::unmap()
{
    if ( mIsMapped ){
        XUnmapWindow(gDpy,mWin);
	XFlush(gDpy);
	mIsMapped = false;
    }
}

//
// pe_line_win
//
pe_line_win::pe_line_win(Window w) : pe_win(w)
{
    set_size(400,40);
    clear();
}

pe_line_win::~pe_line_win()
{
}

void pe_line_win::draw_pe(pe_stat *p)
{
    clear();
    calc_extent(p);
    m_x = 0;
    std::list<pe_jstring>::iterator i;
    for ( i = p->jstrings.begin() ; i != p->jstrings.end() ; i++){
        draw_segment(&(*i));
    }
}

void pe_line_win::draw_segment(pe_jstring *s)
{
    jstring_t::iterator i;
    for ( i = s->s.begin() ; i != s->s.end() ; i++){
        cchar ch= *i;
        draw_char(m_x,20,ch,s->stat);
        m_x += 20;
    }
}

void pe_line_win::calc_extent(pe_stat *p)
{
    int c;
    c = p->get_char_count();
    set_size(400,40);
}


//
// pe_ov_win
//
pe_ov_win::pe_ov_win(Window w) : pe_win(w)
{
    m_mask_pix = 0;
    m_mask_pix_gc = 0;
}

pe_ov_win::~pe_ov_win()
{
    if ( m_mask_pix ){
        XFreePixmap(gDpy,m_mask_pix);
        XFreeGC(gDpy,m_mask_pix_gc);
    }
}

void pe_ov_win::set_size(int w,int h)
{
    if ( w == mWidth && h == mHeight ){
        return ;
    }
    pe_win::set_size(w,h);
    if ( m_mask_pix ){
        XFreePixmap(gDpy,m_mask_pix);
        m_mask_pix = XCreatePixmap(gDpy,mWin
                                   ,mWidth,mHeight,1);
    }
}

void pe_ov_win::draw_ce(char_ent *ce,int len)
{
    if ( m_mask_pix == 0){
	m_mask_pix = XCreatePixmap(gDpy,mWin,mWidth,mHeight,1);
	m_mask_pix_gc = XCreateGC(gDpy,m_mask_pix,0,0);
    }
  
    clear();
    XSetForeground(gDpy,m_mask_pix_gc,BlackPixel(gDpy,DefaultScreen(gDpy)));
    XFillRectangle(gDpy,m_mask_pix,m_mask_pix_gc,0,0,mWidth,mHeight);
    XSetForeground(gDpy,m_mask_pix_gc,WhitePixel(gDpy,DefaultScreen(gDpy)));
    int i;
    for ( i = 0 ; i < len ; i++){
	draw_a_ce(&ce[i]);
    }
    XShapeCombineMask(gDpy,mWin,ShapeBounding,0,0,m_mask_pix,ShapeSet);
}

void pe_ov_win::draw_a_ce(char_ent *ce)
{
    draw_char(ce->x,ce->y,ce->c,ce->stat);
    XFillRectangle(gDpy,m_mask_pix,m_mask_pix_gc,
                   ce->x,ce->y - ce->height+2,
                   ce->width,ce->height+1);
    if ( ce->stat & PE_UNDERLINE ){
        XDrawLine(gDpy,mPixmap,mGC,ce->x,ce->y,ce->x+ce->width,ce->y);
    }
}

//
//
//
CandidateWin::CandidateWin(Convdisp *c)
{
    mConvdisp = c;
    gchar *titles[2]={"index",""};
    bInit = false;
    m_pe = 0;
    
    top_win = gtk_window_new(GTK_WINDOW_POPUP);
    gtk_widget_set_usize(top_win,CAND_WIN_WIDTH,CAND_WIN_HEIGHT);
    clist = gtk_clist_new_with_titles(2,titles);
    gtk_container_add(GTK_CONTAINER(top_win),clist);
    gtk_clist_set_column_width(GTK_CLIST(clist),0,50);
    gtk_clist_set_column_width(GTK_CLIST(clist),1,150);
    
    gtk_widget_show(clist);
    add_widget_watch(clist,WIDGET_ROW_SELECTED,this);
    add_widget_watch(top_win,WIDGET_KEY_PRESS,this);
    m_select_count = 0;
}

CandidateWin::~CandidateWin()
{
    if ( g_cur_cand_win == this ){
	g_cur_cand_win = 0;
    }
    gtk_widget_destroy(top_win);
}

void CandidateWin::select_row(GtkWidget *w,int row,int col)
{
    if ( m_select_count == 0 ){
	m_pe->cands->nth = row;
	mConvdisp->candidate_selected(row);
    }else{
	m_select_count --;
    }
}

void CandidateWin::key_press(GtkWidget *w,GdkEventKey *e)
{
    keyState k(e);
    if ( k.is_modifier()){
        return ;
    }
    m_pe->cont->push_key(&k);
}

void CandidateWin::set_pos(int x,int y)
{
    gtk_widget_set_uposition(top_win,x,y);
}

void CandidateWin::update(pe_stat *pe)
{
    m_pe = pe;
    if ( pe->cands ){
	int nth = m_pe->cands->nth;
	if ( !bInit){
	    m_base_row = 0;
	    bInit = true;
	    build_candidate_list();
	    m_select_count = 1;
	}
    
	if ( trim_base_row()){
	    build_candidate_list();
	    m_select_count = 1;
	}

	show();
	gtk_clist_select_row((GtkCList*)clist,nth-m_base_row,0);
	m_select_count ++;
    }else{
	bInit = false;
	gtk_widget_hide(top_win);
	gtk_clist_clear((GtkCList*)clist);
    }
}

bool CandidateWin::trim_base_row()
{
    int nth = m_pe->cands->nth;

    if ( m_base_row +CAND_COUNT > nth && m_base_row <= nth){
	return false;
    }
    while ( m_base_row +CAND_COUNT <= nth ){
	m_base_row += CAND_COUNT;
    }
    while( m_base_row > nth ){
	m_base_row -=CAND_COUNT;
    }
    return true;
}

void CandidateWin::build_candidate_list()
{
    int i;
    int size = m_pe->cands->cands.size();
    char idx[12];
    char *buf[2];
    gtk_clist_clear((GtkCList*)clist);
    for ( i = m_base_row ; i < (int)size && i < m_base_row + CAND_COUNT; i++){
	char *c;
	if ( i == m_base_row && i > 0){
	    sprintf(idx,"%d(<<)",i+1);
	}else if ( i == m_base_row +CAND_COUNT -1 && i<size){
	    sprintf(idx,"%d(>>)",i+1);
	}else {
	    sprintf(idx,"%d",i+1);
	}
	c = jstring_to_str(&m_pe->cands->cands[i]);
	buf[0]= idx;
	buf[1] = c;
	gtk_clist_append((GtkCList*)clist,buf);
	free(c);
    }
    sprintf(idx,"(%d/%d)",m_base_row,size);
    buf[0] = "";
    buf[1] = idx;
    gtk_clist_append((GtkCList*)clist,buf);
}

void CandidateWin::show()
{
    if (m_pe && m_pe->cands && bInit) {
	if ( g_cur_cand_win && g_cur_cand_win !=this){
	    g_cur_cand_win->hide();
	}
	g_cur_cand_win = this;
	gtk_widget_show(top_win);
    }
}

void CandidateWin::hide()
{
    gtk_widget_hide(top_win);
}

//
//
//
Convdisp::Convdisp(KKContext *k,icxatr *a)
{
    m_kkContext = k;
    m_atr = a;
    m_cands_win = new CandidateWin(this);
}

Convdisp::~Convdisp()
{
    delete m_cands_win;
}

void Convdisp::set_pe(pe_stat *p)
{
    m_pe = p;
}

void Convdisp::candidate_selected(int n)
{
    if ( n == 12 ){
        return ;
    }
    m_kkContext->candidate_selected(n);
}

//롼ȥɥ
convdisp_rw::convdisp_rw(KKContext *k,icxatr *a) : Convdisp(k,a)
{
    m_pe_win = new pe_line_win(DefaultRootWindow(gDpy));
}

convdisp_rw::~convdisp_rw()
{
    delete m_pe_win;
}

void convdisp_rw::update_preedit()
{
    if ( m_pe && m_pe->get_char_count()){
	// preeditȤ¸ߤ
	m_pe_win->do_map();
	m_pe_win->draw_pe(m_pe);
	m_pe_win->draw();
    }else{
	m_pe_win->clear();
	m_pe_win->expose(0);
	XFlush(gDpy);
    }
    m_cands_win->set_pos(0,0);
    m_cands_win->update(m_pe);
}

void convdisp_rw::update_icxatr()
{
}

//Over the spot style
convdisp_ov::convdisp_ov(KKContext *k,icxatr *a) : Convdisp(k,a)
{
    m_ov_win = 0;
}

convdisp_ov::~convdisp_ov()
{
    if ( m_ov_win ){
	delete m_ov_win;
    }
}

void convdisp_ov::update_preedit()
{
    if ( !m_pe ){
	return ;
    }

    // preedit
    draw_preedit();

    // update candidate window
    if ( m_atr->has_atr(ICA_FocusWindow)
	 && m_atr->has_atr(ICA_SpotLocation)){
	int x,y;
	Window win;
	XTranslateCoordinates(gDpy,m_atr->focus_window,
			      DefaultRootWindow(gDpy),
			      m_atr->spot_location.x,
			      m_atr->spot_location.y,
			      &x,&y,&win);
	if ( x + CAND_WIN_WIDTH > scr_width ){
	    x = scr_width - CAND_WIN_WIDTH;
	}
	if ( x < 0 ){
	    x = 0;
	}
	if ( y + CAND_WIN_HEIGHT > scr_height ){
	    //¦˸䥦ɥФ
	    y -= (CAND_WIN_HEIGHT+m_atr->line_space+2);
	}else{
	    // ¦˸䥦ɥФ
	    y+= 2;
	}
	m_cands_win->set_pos(x,y);
    }else{
	m_cands_win->set_pos(0,0);
    }
    m_cands_win->update(m_pe);
}

void convdisp_ov::update_icxatr()
{
    if ( !m_ov_win){
        return ;
    }
    
    if ( m_atr->is_changed(ICA_FocusWindow)){
        if ( !check_win() ){
            return ;
        }
    }
    
    if ( m_atr->is_changed(ICA_Area)){
	m_ov_win->set_size(m_atr->area.width,m_atr->area.height);
	m_atr->unset_change_mask(ICA_Area);
    }
  
    if ( m_atr->is_changed(ICA_Foreground)){
	m_ov_win->set_fore(m_atr->foreground_pixel);
	m_atr->unset_change_mask(ICA_Foreground);
    }
    if ( m_atr->is_changed(ICA_Background)){
	m_ov_win->set_back(m_atr->background_pixel);
	m_atr->unset_change_mask(ICA_Background);
    }
    if ( m_atr->is_changed(ICA_FontSet)){
	m_ov_win->set_fontset(m_atr->font_set);
	m_atr->unset_change_mask(ICA_FontSet);
    }
  
    update_preedit();
}

void convdisp_ov::set_focus()
{
    m_cands_win->show();
}

void convdisp_ov::unset_focus()
{
}

void convdisp_ov::draw_preedit()
{
    m_ce_len = m_pe->get_char_count();
    if ( !check_win()){
	return ;
    }

    m_ce = ( char_ent *)malloc(sizeof(char_ent)*m_ce_len);
    make_ce_array();//ơ
    calc_char_extent();//쥤Ȥơ
    do_draw_preedit();//
    free(m_ce);
    m_cands_win->update(m_pe);
    m_ov_win->draw();
    XFlush(gDpy);
}

void convdisp_ov::do_draw_preedit()
{
    m_ov_win->set_pos(0,0);
    m_ov_win->draw_ce(m_ce,m_ce_len);
}

bool convdisp_ov::check_win()
{
    if (!check_atr()){
	//ץꥨǥåȥɥФΤ˽ʬʾ̵
	return false;
    }
  
    if ( m_ov_win && !m_atr->is_changed(ICA_FocusWindow)){
	// ɥupdateɬפ̵
	return true;
    }

    if ( m_ov_win ){
	delete m_ov_win;
    }
  
    m_atr->unset_change_mask(ICA_FocusWindow);
    m_atr->unset_change_mask(ICA_Foreground);
    m_atr->unset_change_mask(ICA_Background);
    m_atr->unset_change_mask(ICA_FontSet);
    m_ov_win = new pe_ov_win(m_atr->focus_window);
    m_ov_win->set_fore(m_atr->foreground_pixel);
    m_ov_win->set_back(m_atr->background_pixel);
    m_ov_win->set_fontset(m_atr->font_set);
    m_ov_win->do_map();
  
    return true;
}

bool convdisp_ov::check_atr()
{
    if ( !m_atr->has_atr(ICA_FocusWindow)){
	return false;
    }
    if ( !m_atr->has_atr(ICA_SpotLocation)){
	//Ͼ꤬̤ʤ麸
	m_atr->spot_location.x = 0;
	m_atr->spot_location.y = 0;
    }
    if ( !m_atr->has_atr(ICA_Area) ){
	Window r;
	int x;
	unsigned int b,w,h;
	XGetGeometry(gDpy,m_atr->client_window,&r,
		     &x,&x,&w,&h,&b,&b);
	m_atr->area.width = w;
	m_atr->area.height = h;
	m_atr->area.x = 0;
	m_atr->area.y = 0;
    }
    if ( !m_atr->has_atr(ICA_FontSet)){
	m_atr->font_set = gFontset;
    }
    if ( !m_atr->has_atr(ICA_LineSpace)){
	m_atr->line_space = 14;
    }
    if ( !m_atr->has_atr(ICA_Foreground)){
	m_atr->foreground_pixel = BlackPixel(gDpy,DefaultScreen(gDpy));
    }
    if ( !m_atr->has_atr(ICA_Background)){
	m_atr->background_pixel = WhitePixel(gDpy,DefaultScreen(gDpy));
    }
    return true;
}

void convdisp_ov::make_ce_array()
{
    std::list<pe_jstring>::iterator i;
    jstring_t::iterator j;
    int s;
    int c=0;
    for ( i = m_pe->jstrings.begin() ; i != m_pe->jstrings.end() ; i++){
	s = (*i).stat;
	for ( j = (*i).s.begin() ; j != (*i).s.end() ; j++){
	    m_ce[c].c = *j;
	    m_ce[c].stat = s;
	    c++;
	}
    }
}

void convdisp_ov::calc_char_extent()
{
    int i;
    int x,y;
    x = m_atr->spot_location.x;
    y = m_atr->spot_location.y;
    for ( i = 0 ; i < m_ce_len ; i++){
	cchar ch = m_ce[i].c;
	char buf[2];
	int l;
	XRectangle ink,logical;
	if ( ch < 256 ){
	    buf[0] = ch;
	    l = 1;
	}else{
	    buf[1]=(ch & 255)|0x80;
	    buf[0]=((ch>>8)&255)|0x80;
	    l = 2;
	}
	XmbTextExtents(m_atr->font_set,buf,l,&ink,&logical);
	m_ce[i].width = logical.width;
	m_ce[i].height = logical.height;
	if ( m_ce[i].width + x > m_atr->area.width ){
	    x = 0;
	    y +=m_atr->line_space;
	}
	m_ce[i].x = x;
	m_ce[i].y = y;
	x += m_ce[i].height;
    }
}

int convdisp_ov::calc_ce_width(int b,int e)
{
    int i,w=0;
    for ( i = b ; i < e ; i++){
        w += m_ce[i].width;
    }
    return w;
}

convdisp_os::convdisp_os(KKContext *k,icxatr *a,Connection *c) : Convdisp(k,a)
{
    XimIC *ic=k->get_ic();
    mConn = c;
    mImid = ic->get_imid();
    mIcid = ic->get_icid();
    mPrevLen = 0;
}

convdisp_os::~convdisp_os()
{
}

void convdisp_os::update_preedit()
{
    if ( !m_pe ){
        return ;
    }
    update_CandidateWin();
    TxPacket *t;

    int len;
    len = m_pe->get_char_count();

    if ( mPrevLen == 0 && len == 0){
	return ;
    }
    if ( mPrevLen == 0 && len ){
	t = createTxPacket(XIM_PREEDIT_START,0);
	t->pushC16(mImid);
	t->pushC16(mIcid);
	mConn->push_passive_packet(t);
    }

    t = createTxPacket(XIM_PREEDIT_DRAW,0);
    t->pushC16(mImid);
    t->pushC16(mIcid);
    t->pushC32(0);// caret
    t->pushC32(0); // chg_first
    t->pushC32(mPrevLen); // chg_length
    t->pushC32(0); //feedback array 򥻥åȤʤmozilla뤬IMEȹͤΤ̤
  
    compose_preedit_array(t);
    compose_feedback_array(t);
    mConn->push_passive_packet(t);

    if ( mPrevLen && len == 0){
	t = createTxPacket(XIM_PREEDIT_DONE,0);
	t->pushC16(mImid);
	t->pushC16(mIcid);
	mConn->push_passive_packet(t);
    }
    mPrevLen = len;
    /*
      t = createTxPacket(XIM_PREEDIT_CARET,0);
      t->pushC16(mImid);
      t->pushC16(mIcid);
      t->pushC32(pos);
      t->pushC32(dir);
      t->pushC32(style);
      mConn->push_passive_packet(t);
      */
      
}

void convdisp_os::update_icxatr()
{
}

void convdisp_os::compose_preedit_array(TxPacket *t)
{
    jstring_t s;
    std::list<pe_jstring>::iterator it;
    for ( it = m_pe->jstrings.begin() ; it != m_pe->jstrings.end() ; it++){
        append_jstring(&s,&(*it).s);
    }

    char *c = jstring_to_ctext(&s);
    int i,len;
    len = strlen(c);
    t->pushC16(len);// LENGTH
    for ( i = 0 ; i < len ; i++){
        t->pushC8(c[i]); // CTEXT
    }
    len = pad4(len+2);
    for ( i = 0 ; i < len ; i++){
        t->pushC8(0); // PADDING
    }
    free(c);
}

void convdisp_os::compose_feedback_array(TxPacket *t)
{
    int i,len,stat,xstat;
    len = m_pe->get_char_count();
    t->pushC16(len*4);
    t->pushC16(0);
    std::list<pe_jstring>::iterator it;
    for ( it = m_pe->jstrings.begin() ; it != m_pe->jstrings.end() ; it++){
        len = (*it).s.size();
        stat = (*it).stat;
        xstat = FB_None;
        if ( stat & PE_REVERSE){
            xstat |= FB_Reverse;
        }
        if ( stat & PE_UNDERLINE){
            xstat |= FB_Underline;
        }
        if ( stat & PE_HILIGHT){
            xstat |= FB_Highlight;
        }
        for ( i = 0 ; i < len  ; i++){
            t->pushC32(xstat);
        }
    }
}

void convdisp_os::set_focus()
{
    m_cands_win->show();
}

void convdisp_os::unset_focus()
{
}

void convdisp_os::update_CandidateWin()
{
    m_cands_win->set_pos(0,0);
    m_cands_win->update(m_pe);
}
/*
 * Local variables:
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 */
